#! usr/bin/python3.6
"""
    Module initially auto generated using V5Automation files from CATIA V5 R28 on 2020-06-11 12:40:47.360445

    .. warning::
        The notes denoted "CAA V5 Visual Basic Help" are to be used as reference only.
        They are there as a guide as to how the visual basic / catscript functions work
        and thus help debugging in pycatia.
        
"""

from pycatia.part_interfaces.boolean_shape import BooleanShape


class Assemble(BooleanShape):
    """
        .. note::
            :class: toggle

            CAA V5 Visual Basic Help (2020-06-11 12:40:47.360445)

                | System.IUnknown
                |     System.IDispatch
                |         System.CATBaseUnknown
                |             System.CATBaseDispatch
                |                 System.AnyObject
                |                     MecModInterfaces.Shape
                |                         PartInterfaces.BooleanShape
                |                             Assemble
                | 
                | Represents the assemble boolean operation.
                | It is performed between a body and the current shape. An assemble operation
                | adds material if the body is "positive" and remove material if the body is
                | "negative".

    """

    def __init__(self, com_object):
        super().__init__(com_object)
        self.assemble = com_object

    def __repr__(self):
        return f'Assemble(name="{self.name}")'
